////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//	-You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////
function RandomSquareGenerator(phaser, game){
	
	var th_ = this;
	
	var graphics;
	
	this.rectangles = [];
	
	var timedEvent;
	
	this.create = function(){
		
		graphics = phaser.add.graphics({x: 0, y: 0});
		
	}
	
	function onCompleteHandler(tween, targets, arg){
		
		for (var i = 0; i < th_.rectangles.length; ++i){
			
			var rect = th_.rectangles[i];
			
			if(rect == arg){
				th_.rectangles.splice(i, 1);
			}

		}
		
	}
	
	this.start = function(){
		
		var rec = new Square();
		
		var randType = Phaser.Math.Between(0, 1);
		
		rec.type = randType;
		
		th_.rectangles.push(rec);
		
		var randSize = Phaser.Math.Between(5, 100);
		var randSize2 = Phaser.Math.Between(5, 100);
		
		var halfRandSize = randSize * 0.5;
		
		var halfRandSize2 = randSize2 * 0.5;
		
		var secureX = 150;
		
		rec.x = 800 + secureX;
		
		rec.y = Phaser.Math.Between(0, game.canvas.height);
		
		var duration = Phaser.Math.Between(6000, 20000);
		
		var tween = phaser.tweens.add({
			targets: rec,
			x: 0 - secureX,
			ease: 'Power1',
			duration: duration,
			onComplete: onCompleteHandler,
			onCompleteParams: [ rec ]
		});
		
		
		
		rec.width = randSize;
		rec.height = randSize;
		
		
		
		var tween = phaser.tweens.add({
			targets: rec,
			width: randSize2,
			height: randSize2,
			ease: 'Power1',
			duration: duration,
			onComplete: onCompleteHandler,
			onCompleteParams: [ rec ]
		});
		
		var randrotation = Phaser.Math.DegToRad(Phaser.Math.Between(-360, 360));
		var randrotatio2 = Phaser.Math.DegToRad(Phaser.Math.Between(-360, 360));
		
		rec.rotation = randrotation;
		
		var tween = phaser.tweens.add({
			targets: rec,
			rotation: randrotatio2,
			ease: 'Power1',
			duration: duration,
			onComplete: onCompleteHandler,
			onCompleteParams: [ rec ]
		});
		
		var randAlpha1 = Phaser.Math.Between(0, 20) / 100;
		var randAlpha2 = Phaser.Math.Between(0, 5) / 100;
		
		rec.fillAlpha = randAlpha1;
		
		var tween = phaser.tweens.add({
			targets: rec,
			fillAlpha: randAlpha2,
			ease: 'Sine.easeInOut',
			duration: Phaser.Math.Between(1000, 4000),
			yoyo: true,
			repeat: -1
			
		});
		
	}
	
	function drawStar(gfx, cx, cy, spikes, outerRadius, innerRadius, color, lineColor) {
		var rot = Math.PI / 2 * 3;
		var x = cx;
		var y = cy;
		var step = Math.PI / spikes;
		//gfx.lineStyle(10, lineColor, 1.0);
		//gfx.fillStyle(color, 1.0);
		gfx.beginPath();
		gfx.moveTo(cx, cy - outerRadius);
		for (i = 0; i < spikes; i++) {
			x = cx + Math.cos(rot) * outerRadius;
			y = cy + Math.sin(rot) * outerRadius;
			gfx.lineTo(x, y);
			rot += step;

			x = cx + Math.cos(rot) * innerRadius;
			y = cy + Math.sin(rot) * innerRadius;
			gfx.lineTo(x, y);
			rot += step;
		}
		gfx.lineTo(cx, cy - outerRadius);
		gfx.closePath();
		gfx.fillPath();
		//gfx.strokePath();
	}
	
	this.update = function(){
		
		graphics.clear();
    
		for (var i = 0; i < th_.rectangles.length; ++i){
			
			var rect = th_.rectangles[i];
			graphics.fillStyle(0x000000, rect.fillAlpha);
			graphics.lineStyle(4.0, 0xFF0000, rect.strokeAlpha);
			
			var x = rect.x - (rect.width / 2);
			var y = rect.y - (rect.height / 2);
			var w = rect.width;
			var h = rect.height;
			
			graphics.save();
			graphics.translate(x, y);
			graphics.rotate(rect.rotation);
			
			switch(rect.type){
				case 1:{
					graphics.fillCircle(-rect.width / 2, -rect.height / 2, w);
				}break;
				case 2:{
					drawStar(graphics, 0, 0, 3, w - 10, w + 10, 0x000000);
				}break;
				default:{
					graphics.fillRect(-rect.width / 2, -rect.height / 2, w, h);
				}
			}
			
			
			
			graphics.restore();
			//graphics.strokeRect(x, y, w, h);

		}
	}
	
}

function Square(){
	
	this.type = 0;
	
	this.x = 0;
	this.y = 0;
	this.width = 5;
	this.height = 5;
	this.rotation = 0;
	this.fillAlpha = 1;
	this.strokeAlpha = 1;
}